<template>
  <GI18nCard :i18n="i18n" :card="card" v-bind="$attrs">
    <v-row dense>
      <GCol cols="12" md="4">
        <GTextField
          v-model="value._attr.refType"
          i18n="dcc.common.attributes.refType"
          attr-ref-type
        />
      </GCol>
      <GCol cols="12" md="4">
        <GTextField
          v-model="value._attr.id"
          i18n="dcc.common.attributes.id"
          attr-ref-type
        />
      </GCol>
      <GCol cols="12" md="4">
        <GTextField
          v-model="value._attr.refId"
          i18n="dcc.common.attributes.refId"
          attr-ref-type
        />
      </GCol>
      <GCol cols="12">
        <DccLocalizedTextBlock
          v-model="value.name"
          i18n="dcc.common.statementType.name"
        />
      </GCol>
      <GCol v-if="value.description" cols="12">
        <RichContent
          ref="description"
          v-model="value.description"
          i18n="dcc.common.richContentType.description.title"
          optional
          :not-in-dialog="notInDialog"
          @delete="deleteDescriptionRichContent"
        />
      </GCol>
      <GCol cols="12" md="6">
        <GAutocomplete
          v-model="countryCodeISO3166_1"
          :items="countryCodes"
          :item-text="(item) => `${item.code} - ${item.name}`"
          item-value="code"
          i18n="dcc.common.statementType.countryCodeISO3166_1"
        />
      </GCol>
      <GCol cols="12" md="6">
        <XmlTextField
          v-model="value.convention"
          i18n="dcc.common.statementType.convention"
          validate="notEmptyStringType"
        />
      </GCol>
      <GCol cols="12" md="6">
        <DccArrayWrapper
          v-model="value.norm"
          :component="XmlTextField"
          i18n="dcc.common.statementType.norm"
          validate="notEmptyStringType"
        />
      </GCol>
      <GCol cols="12" md="6">
        <DccArrayWrapper
          v-model="value.reference"
          :component="XmlTextField"
          i18n="dcc.common.statementType.reference"
          validate="notEmptyStringType"
        />
      </GCol>
      <GCol v-if="value.declaration" cols="12">
        <RichContent
          ref="declaration"
          v-model="value.declaration"
          i18n="dcc.common.richContentType.declaration.title"
          optional
          :not-in-dialog="notInDialog"
          level="second"
          wiki-entry="richContent"
          @delete="deleteDeclarationRichContent"
        />
      </GCol>
      <GCol v-if="value.valid || value.validXMLList" cols="12">
        <GI18nCard
          :ref="value.valid ? 'valid' : 'validXMLList'"
          :i18n="`dcc.common.statementType.${
            value.valid ? 'valid' : 'validXMLList'
          }.title`"
          level="third"
          :card="true"
          optional
          @deleteElement="deleteValid"
        >
          <DccCheckbox
            v-if="value.valid"
            v-model="value.valid"
            i18n="dcc.common.statementType.valid.title"
          />
          <XmlTextField
            v-if="value.validXMLList"
            v-model="value.validXMLList"
            i18n="dcc.common.statementType.validXMLList.title"
            validate="required booleanList"
          />
        </GI18nCard>
      </GCol>
      <GCol cols="12" md="6">
        <DccCheckbox
          v-model="value.traceable"
          i18n="dcc.common.statementType.traceable"
        />
      </GCol>
      <GCol cols="12" md="6">
        <DccDatePicker
          v-model="value.date"
          i18n="dcc.common.statementType.date"
        />
      </GCol>
      <GCol cols="12">
        <XmlTextField
          v-model="value.period"
          i18n="dcc.common.statementType.period"
          :rules="durationRules"
        />
      </GCol>
      <GCol cols="12">
        <GCheckbox
          v-model="hasRespAuthorityCheckboxState"
          i18n="dcc.common.statementType.hasRespAuthority"
          @change="hasRespAuthorityCheckboxChange"
        />
        <Contact
          v-if="value.respAuthority"
          v-model="value.respAuthority"
          level="third"
          wiki-entry="respAuthority"
          i18n="dcc.common.statementType.respAuthority"
        />
      </GCol>
      <GCol v-if="value.conformity || value.conformityXMLList" cols="12">
        <GI18nCard
          :ref="value.conformity ? 'conformity' : 'conformityXMLList'"
          i18n="dcc.common.statementType.conformity"
          level="third"
          :card="true"
          optional
          wiki-entry="conformity"
          @deleteElement="deleteConformity"
        >
          <DccSelect
            v-if="value.conformity"
            v-model="value.conformity"
            :items="stringConformityStatementStatus"
            i18n="dcc.tables.conformity.title"
            clearable
          />
          <XmlTextField
            v-if="value.conformityXMLList"
            v-model="value.conformityXMLList"
            i18n="dcc.tables.conformityXMLList.title"
          />
        </GI18nCard>
      </GCol>
      <GCol v-if="value.data && value.data.quantity" cols="12">
        <QuantityList
          ref="quantities"
          v-model="value.data"
          optional
          level="second"
          @delete="deleteData"
        />
      </GCol>
      <GCol cols="12" md="6">
        <XmlTextField
          v-model="value.nonSIDefinition"
          i18n="dcc.common.statementType.nonSIDefinition"
          validate="notEmptyStringType"
          optional
        />
      </GCol>
      <GCol cols="12" md="6">
        <XmlTextField
          v-model="value.nonSIUnit"
          i18n="dcc.common.statementType.nonSIUnit"
          validate="notEmptyStringType"
          optional
        />
      </GCol>
      <GCol cols="12">
        <GCheckbox
          v-model="hasLocationCheckboxState"
          i18n="dcc.common.contactType.hasLocation"
          @change="hasLocationCheckboxChange"
        />
        <Location
          v-if="hasLocationCheckboxState && value.location"
          v-model="value.location"
          i18n="dcc.common.locationType.title"
          :card="true"
          v-bind="$attrs"
        />
      </GCol>
    </v-row>
  </GI18nCard>
</template>

<script>
import {
  ContactType,
  DataType,
  DCCXMLBoolean,
  DCCXMLElement,
  LocationType,
  RichContentType,
} from "@d-ptb/dcc-js";
import { DCCXMLList } from "@d-ptb/dcc-js/lib/DCC";
import GI18nCard from "../../App/Common/GI18nCard";
import GAutocomplete from "../../App/Form/gAutocomplete";
import XmlTextField from "../../App/Form/XML/XmlTextField";
import DccCheckbox from "../../App/Form/XML/XmlCheckbox";
import DccDatePicker from "../../App/Form/XML/DccDatePicker";
import { firstOrDefault, insertIf } from "~/assets/util/general";
import ISO3611 from "~/assets/lists/iso-3611-codes";
import DccArrayWrapper from "~/components/App/Form/XML/DccArrayWrapper";
import RichContent from "~/components/DCC/Common/RichContent";
import GCheckbox from "~/components/App/Form/gCheckbox";
import Contact from "~/components/DCC/Common/Contact";
import DccSelect from "~/components/App/Form/XML/DccSelect";
import GTextField from "~/components/App/Form/gTextField";
import Location from "~/components/DCC/Common/Location";
import GCol from "~/components/App/Common/GCol";
import DccLocalizedTextBlock from "~/components/App/Form/XML/DccLocalizedTextBlock";

const stringConformityStatementStatus = [
  "pass",
  "fail",
  "conditionalPass",
  "conditionalFail",
  "noPass",
  "noFail",
];

export default {
  name: "StatementMetaData",
  components: {
    DccLocalizedTextBlock,
    GCol,
    GTextField,
    DccSelect,
    Contact,
    GCheckbox,
    // Needs to be imported asynchronously because of recursive components
    QuantityList: () => import("~/components/DCC/Common/QuantityList"),
    RichContent,
    DccArrayWrapper,
    DccDatePicker,
    DccCheckbox,
    XmlTextField,
    GAutocomplete,
    GI18nCard,
    Location,
  },
  props: {
    value: Object,
    updateAvailableElements: Function,
    i18n: {
      type: String,
      default: "dcc.common.statementType.title",
    },
    card: {
      type: Boolean,
      default: true,
    },
    title: String,
    notInDialog: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      lastRespAuthority: null,
      hasRespAuthorityCheckboxState: !!this.value.respAuthority,
      lastLocation: null,
      hasLocationCheckboxState: !!this.value.location,
      countryCodes: ISO3611,
      durationRules: [
        (v) =>
          !v ||
          /^(-?P(\d*Y)?(\d*M)?(\d*D)?(T(\d*H)?(\d*M)?(\d*S)?)?)?$/gm.test(v) ||
          this.$t("form.errors._default", [
            this.$t("dcc.common.statementType.period"),
          ]),
      ],
      XmlTextField,
    };
  },
  computed: {
    titleText() {
      return this.i18n ? this.$t(this.i18n) : this.title;
    },
    countryCodeISO3166_1: {
      get() {
        const el = firstOrDefault(this.value.countryCodeISO3166_1);
        return el ? el._text : "";
      },
      set(val) {
        if (val) {
          this.value.countryCodeISO3166_1 = [new DCCXMLElement({ _text: val })];
        } else {
          this.value.countryCodeISO3166_1 = null;
        }
      },
    },
    stringConformityStatementStatus() {
      return stringConformityStatementStatus.map((x) => {
        return {
          key: x,
          text: this.$t(`dcc.common.stringConformityStatementStatusType.${x}`),
        };
      });
    },
    availableElements() {
      return [
        "description",
        "declaration",
        "valid",
        "validXMLList",
        "conformity",
        "conformityXMLList",
        "quantities",
      ]
        .filter((x) => !this.blacklist.includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.statementList.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    blacklist() {
      return [
        ...insertIf(this.value.description, "description"),
        ...insertIf(this.value.declaration, "declaration"),
        ...insertIf(this.value.valid, "valid", "validXMLList"),
        ...insertIf(this.value.validXMLList, "valid", "validXMLList"),
        ...insertIf(this.value.conformity, "conformity", "conformityXMLList"),
        ...insertIf(
          this.value.conformityXMLList,
          "conformity",
          "conformityXMLList"
        ),
        ...insertIf(this.value.data && this.value.data.quantity, "quantities"),
      ];
    },
  },
  watch: {
    value(val) {
      this.hasRespAuthorityCheckboxState = !!val.respAuthority;
      this.hasLocationCheckboxState = !!val.location;
    },
    availableElements: {
      handler() {
        if (typeof this.updateAvailableElements === "function")
          this.updateAvailableElements(this.availableElements);
      },
      immediate: true,
      deep: true,
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "description":
          this.$set(this.value, "description", new RichContentType());
          break;
        case "declaration":
          this.$set(this.value, "declaration", new RichContentType());
          break;
        case "valid":
          this.$set(this.value, "valid", new DCCXMLBoolean());
          break;
        case "validXMLList":
          this.$set(this.value, "validXMLList", new DCCXMLList());
          break;
        case "conformity":
          this.$set(this.value, "conformity", new DCCXMLElement());
          break;
        case "conformityXMLList":
          this.$set(this.value, "conformityXMLList", new DCCXMLList());
          break;
        case "quantities":
          this.$set(
            this.value,
            "data",
            new DataType({
              quantity: [],
            })
          );
          break;
      }
      this.$nextTick(() => {
        this.$refs[element].$el.scrollIntoView({
          behavior: "smooth",
        });
      });
    },
    hasRespAuthorityCheckboxChange(val) {
      if (val) {
        this.value.respAuthority = this.lastRespAuthority || new ContactType();
      } else {
        this.lastRespAuthority = this.value.respAuthority;
        this.$delete(this.value, "respAuthority");
      }
    },
    hasLocationCheckboxChange(val) {
      if (val) {
        this.value.location = this.lastLocation || new LocationType();
      } else {
        this.lastLocation = this.value.location;
        this.$delete(this.value, "location");
      }
    },
    deleteData() {
      confirm(this.$t("dcc.tables.quantityList.confirmRemove")) &&
        this.$delete(this.value, "data");
    },
    deleteConformity() {
      if (confirm(this.$t("dcc.tables.conformity.confirmRemove"))) {
        if (this.value.conformity) {
          this.$delete(this.value, "conformity");
        } else if (this.value.conformityXMLList) {
          this.$delete(this.value, "conformityXMLList");
        }
      }
    },
    deleteDeclarationRichContent() {
      confirm(
        this.$t("dcc.common.richContentType.declaration.confirmRemove")
      ) && this.$delete(this.value, "declaration");
    },
    deleteDescriptionRichContent() {
      confirm(
        this.$t("dcc.common.richContentType.description.confirmRemove")
      ) && this.$delete(this.value, "description");
    },
    deleteValid() {
      if (this.value.valid) {
        if (confirm(this.$t("dcc.common.statementType.valid.confirmRemove"))) {
          this.$delete(this.value, "valid");
        }
      } else if (
        confirm(this.$t("dcc.common.statementType.validXMLList.confirmRemove"))
      ) {
        this.$delete(this.value, "validXMLList");
      }
    },
  },
};
</script>
